// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.17.0
// source: queries.sql

package db

import (
	"context"
	"database/sql"
)

const insertPackage = `-- name: InsertPackage :exec
INSERT INTO renovate (
  platform,
  organisation,
  repo,

  package_name,
  version,
  locked_version,

  package_manager,
  package_file_path,

  datasource,
  dep_types
  ) VALUES (
  ?,
  ?,
  ?,

  ?,
  ?,
  ?,

  ?,
  ?,

  ?,
  ?
)
`

type InsertPackageParams struct {
	Platform        string
	Organisation    string
	Repo            string
	PackageName     string
	Version         string
	LockedVersion   sql.NullString
	PackageManager  string
	PackageFilePath string
	Datasource      string
	DepTypes        sql.NullString
}

func (q *Queries) InsertPackage(ctx context.Context, arg InsertPackageParams) error {
	_, err := q.db.ExecContext(ctx, insertPackage,
		arg.Platform,
		arg.Organisation,
		arg.Repo,
		arg.PackageName,
		arg.Version,
		arg.LockedVersion,
		arg.PackageManager,
		arg.PackageFilePath,
		arg.Datasource,
		arg.DepTypes,
	)
	return err
}

const queryGolangCILintDirect = `-- name: QueryGolangCILintDirect :many
select
distinct
platform,
organisation,
repo
from
renovate,
json_each(renovate.dep_types) as dep_type
where
package_name = 'github.com/golangci/golangci-lint'
and package_manager = 'gomod'
and dep_type.value = 'require'
`

type QueryGolangCILintDirectRow struct {
	Platform     string
	Organisation string
	Repo         string
}

// preferably with a `json_each` but due to https://github.com/kyleconroy/sqlc/issues/1830 we need to handle it like this
func (q *Queries) QueryGolangCILintDirect(ctx context.Context) ([]QueryGolangCILintDirectRow, error) {
	rows, err := q.db.QueryContext(ctx, queryGolangCILintDirect)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []QueryGolangCILintDirectRow
	for rows.Next() {
		var i QueryGolangCILintDirectRow
		if err := rows.Scan(&i.Platform, &i.Organisation, &i.Repo); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const queryGolangCILintIndirect = `-- name: QueryGolangCILintIndirect :many
select
distinct
platform,
organisation,
repo
from
renovate,
json_each(renovate.dep_types) as dep_type
where
package_name = 'github.com/golangci/golangci-lint'
and package_manager = 'gomod'
and dep_type.value = 'indirect'
`

type QueryGolangCILintIndirectRow struct {
	Platform     string
	Organisation string
	Repo         string
}

// preferably with a `json_each` but due to https://github.com/kyleconroy/sqlc/issues/1830 we need to handle it like this
func (q *Queries) QueryGolangCILintIndirect(ctx context.Context) ([]QueryGolangCILintIndirectRow, error) {
	rows, err := q.db.QueryContext(ctx, queryGolangCILintIndirect)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []QueryGolangCILintIndirectRow
	for rows.Next() {
		var i QueryGolangCILintIndirectRow
		if err := rows.Scan(&i.Platform, &i.Organisation, &i.Repo); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const queryGorillaToolkitDirect = `-- name: QueryGorillaToolkitDirect :many
select
count(*),
package_name
from
renovate,
json_each(renovate.dep_types) as dep_type
where
package_name like 'github.com/gorilla/%'
and datasource = 'go'
and dep_type.value = 'require'
group by package_name order by count(*) DESC
`

type QueryGorillaToolkitDirectRow struct {
	Count       int64
	PackageName string
}

// preferably with a `json_each` but due to https://github.com/kyleconroy/sqlc/issues/1830 we need to handle it like this
func (q *Queries) QueryGorillaToolkitDirect(ctx context.Context) ([]QueryGorillaToolkitDirectRow, error) {
	rows, err := q.db.QueryContext(ctx, queryGorillaToolkitDirect)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []QueryGorillaToolkitDirectRow
	for rows.Next() {
		var i QueryGorillaToolkitDirectRow
		if err := rows.Scan(&i.Count, &i.PackageName); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const queryGorillaToolkitIndirect = `-- name: QueryGorillaToolkitIndirect :many
select
count(*),
package_name
from
renovate,
json_each(renovate.dep_types) as dep_type
where
package_name like 'github.com/gorilla/%'
and datasource = 'go'
and dep_type.value = 'indirect'
group by package_name order by count(*) DESC
`

type QueryGorillaToolkitIndirectRow struct {
	Count       int64
	PackageName string
}

// preferably with a `json_each` but due to https://github.com/kyleconroy/sqlc/issues/1830 we need to handle it like this
func (q *Queries) QueryGorillaToolkitIndirect(ctx context.Context) ([]QueryGorillaToolkitIndirectRow, error) {
	rows, err := q.db.QueryContext(ctx, queryGorillaToolkitIndirect)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []QueryGorillaToolkitIndirectRow
	for rows.Next() {
		var i QueryGorillaToolkitIndirectRow
		if err := rows.Scan(&i.Count, &i.PackageName); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const queryMostPopularDockerImages = `-- name: QueryMostPopularDockerImages :many
select
package_name, count(package_name)
from renovate
where datasource = 'docker'
and package_name != ''
group by package_name
`

type QueryMostPopularDockerImagesRow struct {
	PackageName string
	Count       int64
}

func (q *Queries) QueryMostPopularDockerImages(ctx context.Context) ([]QueryMostPopularDockerImagesRow, error) {
	rows, err := q.db.QueryContext(ctx, queryMostPopularDockerImages)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []QueryMostPopularDockerImagesRow
	for rows.Next() {
		var i QueryMostPopularDockerImagesRow
		if err := rows.Scan(&i.PackageName, &i.Count); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const queryMostPopularPackageManagers = `-- name: QueryMostPopularPackageManagers :many
SELECT
package_manager,
count(*)
from renovate
group by
package_manager
order by count(*) desc
`

type QueryMostPopularPackageManagersRow struct {
	PackageManager string
	Count          int64
}

func (q *Queries) QueryMostPopularPackageManagers(ctx context.Context) ([]QueryMostPopularPackageManagersRow, error) {
	rows, err := q.db.QueryContext(ctx, queryMostPopularPackageManagers)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []QueryMostPopularPackageManagersRow
	for rows.Next() {
		var i QueryMostPopularPackageManagersRow
		if err := rows.Scan(&i.PackageManager, &i.Count); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const retrieveAll = `-- name: RetrieveAll :many
select platform, organisation, repo, package_name, version, locked_version, package_manager, package_file_path, datasource, dep_types from renovate
`

func (q *Queries) RetrieveAll(ctx context.Context) ([]Renovate, error) {
	rows, err := q.db.QueryContext(ctx, retrieveAll)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Renovate
	for rows.Next() {
		var i Renovate
		if err := rows.Scan(
			&i.Platform,
			&i.Organisation,
			&i.Repo,
			&i.PackageName,
			&i.Version,
			&i.LockedVersion,
			&i.PackageManager,
			&i.PackageFilePath,
			&i.Datasource,
			&i.DepTypes,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}
